Draft CircularArray

From FreeCAD Documentation
Revision as of 10:27, 3 June 2021 by Roy 043 (talk | contribs) (Updated Options)
This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft CircularArray

Menu location
Modification → Array tools → Circular array
Workbenches
Draft
Default shortcut
None
Introduced in version
0.19
See also
Draft OrthoArray, Draft PolarArray, Draft PathArray, Draft PathLinkArray, Draft PointArray, Draft Clone

Description

The Draft CircularArray tool creates an array from a selected object placing the copies along concentric circumferences. This is similar to using PolarArray with a polar angle of 360 degrees, and creating several concentric arrays.

This tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch. It can also create App Links instead of simple copies.

A circular array of an object.

Usage

  1. Select the object from which you wish to array.
  2. Press the Circular array button. If no object is selected, you will be invited to select one before proceeding.
  3. The task panel is launched where you can select the radial distance, the tangential distance, the number of circular layers, the symmetry parameter, and the center of the axis of rotation.
  4. You can click on the 3D view to simultaneously set the position of the center of rotation, and complete the command. Otherwise, just press Enter or the OK button to complete the operation.

Options

  • Enter the Radial distance to specify the distance between the circular layers, and between the center and the first circular layer.
  • Enter the Tangential distance to specify the distance between the elements on the same circular layer. This distance must be large than zero.
  • Enter the Number of circular layers. The element at the center counts as one layer. The minimum is 2, the maximum is 99.
  • Enter the Symmetry value. This number determines how the elements are distributed. A value of 3 will result in a pattern with three equal 120° pie segments. The larger the Symmetry, and the Tangential distance, the fewer elements will fit on the inner circular layers.
  • Pick a point in the 3D view or type coordinates for the Center of rotation. The rotation axis of the array will pass through this point. It is advisable to move the pointer out of the 3D view before entering coordinates.
  • Press the Reset point button to reset the Center of rotation to the origin.
  • If the Fuse checkbox is checked overlapping elements in the array are fused. This does not work for Link arrays.
  • If the Link array checkbox is checked a Link array instead of a regular array is created. A Link array is more efficient because its elements are App Link objects.
  • Press Esc or the Cancel button to abort the command.

Notes

  • The default rotation axis for the array is the positive Z axis. This can be changed by editing its DataAxis property.
  • A Draft CircularArray can be turned into a Draft OrthoArray or a Draft PolarArray by changing its DataArray Type property.
  • A Link array cannot be turned into a regular array or vice versa. The type of array must be decided at creation time.

Properties

See Draft OrthoArray.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a circular array use the make_array method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeArray method. The make_array method can create Draft OrthoArrays, Draft PolarArrays and Draft CircularArrays. For each array type one or more wrappers are available.

The main method:

array = make_array(base_object, arg1, arg2, arg3, arg4=None, arg5=None, arg6=None, use_link=True)

The wrapper for circular arrays is:

array = make_circular_array(base_object,
                            r_distance=100, tan_distance=50,
                            number=3, symmetry=1,
                            axis=App.Vector(0, 0, 1), center=App.Vector(0, 0, 0),
                            use_link=True)
  • base_object is the object to be arrayed. It can also be the Label (string) of an object in the current document.
  • r_distance and tan_distance are the radial and tangential distances between the elements.
  • number is the number of circular layers in the pattern, the original object counts as the first layer.
  • symmetry is an integer used in some calculations that affect the way the elements are distributed around the circumferences. Usual values are from 1 to 6. Higher values are not recommended and will make the elements in the inner layers disappear.
  • axis and center are vectors that describe the direction of the axis of rotation, and a point through which that axis passes.
  • If use_link is True the created elements are App Links instead of regular copies.
  • array is returned with the created array object.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

tri = Draft.make_polygon(3, 600)

array = Draft.make_circular_array(tri, 1800, 1200, 4, 1)
doc.recompute()